'(

@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@ Filename....|.GEAR EFFECTS...........................................................@
@ Revision....|.1.0.0.0................................................................@
@ Controller..|.Attiny45...............................................................@
@ Compiler....|.BASCOM-AVR IDE 2.0.8.1.................................................@
@ Author......|.Rubashka Vasiliy (Radan), LNR, 2025....................................@
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

             .-\/-.
RESET/PB5 1 -|    |- 8 Vcc
      PB3 2 -|    |- 7 PB2/SCK
      PB4 3 -|    |- 6 PB1/MISO
      Gnd 4 -|    |- 5 PB0/MOSI
             '----'

')

Dim Reason_for_reset As Byte                                '     MCUSR
!sts {Reason_for_reset} , R0                                '  R0 Bascom    MCUSR  MCU Status Register

$map                                                        '     Bascom
$regfile = "attiny45.dat"                                   ' 
$crystal = 9600000                                          ',    
$hwstack = 64
$swstack = 64
$framesize = 64


                    ' 
'***************************************************************************************
Config Pinb.0 = Input                                       ' 1
Set Pinb.0                                                  '  
Config Portb.1 = Output                                     '
Config Portb.2 = Output                                     '
Config Portb.3 = Output                                     '
Config Portb.4 = Output                                     '


                    '  0
'***************************************************************************************
Config Timer0 = Timer , Prescale = 64 : On Timer0 Pulse
Enable Timer0
Start Timer0

                    '   1
'***************************************************************************************
Gimsk = &B00100000
Pcmsk = &B00000001
On Pcint0 In_1hz
Enable Pcint0

Enable Interrupts                                           '    

                    ' 
'***************************************************************************************
Dim Flg_1hz As Byte                                         '  
Dim Dat As Word                                             '         
Dim Led As Byte                                             '   
Dim Step_pendul As Byte                                     '   (  )
Dim Effect As Byte                                          ' 
Dim Naprav As Byte                                          ' 
Dim Paus As Byte                                            '   
Dim Temp As Byte                                            ' 
Const Maxeffect = 8 - 1                                     '     (  )

'       
Readeeprom Effect , 3
If Effect > Maxeffect Then Effect = 0

'    "RESET"
If Reason_for_reset.1 = 1 Then
   Reason_for_reset.1 = 0
   Mcusr.1 = 0

   '  
   Incr Effect
   If Effect > Maxeffect Then Effect = 0
   '   
   Writeeeprom Effect , 3

   '   
   Temp = Effect * 13
   Dat = Lookup(temp , Effects)

   '   300
   Waitms 300
End If


'===================================..####.....###...===================================
'===================================..#..##...#..##..===================================
'===================================..#..##...#..##..===================================
'===================================..#..##...#..##..===================================
'===================================..####.....###...===================================
Do                                                          ' 
   '    (      -      )
   If Flg_1hz = 2 Then
      '    
      Toggle Naprav

      If Naprav = 0 Then                                    '    
         For Step_pendul = 0 To 12
            Gosub Stepik
         Next Step_pendul
      Else                                                  '    
         For Step_pendul = 12 To 0 Step -1
            Gosub Stepik
         Next Step_pendul
      End If

      '  
      Flg_1hz = 0
   End If

Loop                                                        '  

'===========================..#........###.....###....####...===========================
'===========================..#.......#..##...#..##...#..##..===========================
'===========================..#.......#..##...#..##...####...===========================
'===========================..#..##...#..##...#..##...#......===========================
'===========================..#####....###.....###....#......===========================



'==========      ==========
'***************************************************************************************
Stepik:
   Temp = Effect * 13
   Temp = Temp + Step_pendul
   Dat = Lookup(temp , Effects)
   Paus = Lookup(step_pendul , Pausis)                      '    
   Waitms Paus
Return

'==========  0  ==========
'***************************************************************************************
Pulse:
   Timer0 = 200
   '  
   Ddrb.1 = 0
   Ddrb.2 = 0
   Ddrb.3 = 0
   Ddrb.4 = 0
   Portb.1 = 0
   Portb.2 = 0
   Portb.3 = 0
   Portb.4 = 0

  ' 
   Incr Led
   If Led = 12 Then Led = 0

   On Led Goto Pir_1 , Pir_2 , Pir_3 , Pir_4 , Pir_5 , Pir_6 , Pir_7 , Pir_8 , Pir_9 , Pir_10 , Pir_11 , Pir_12
Pir_1:
   Portb.3 = Dat.6
   Ddrb.2 = Dat.6
   Ddrb.3 = Dat.6
   !jmp Exits
Pir_2:
   Portb.2 = Dat.7
   Ddrb.2 = Dat.7
   Ddrb.3 = Dat.7
   !jmp Exits
Pir_3:
   Portb.4 = Dat.9
   Ddrb.3 = Dat.9
   Ddrb.4 = Dat.9
   !jmp Exits
Pir_4:
   Portb.3 = Dat.8
   Ddrb.3 = Dat.8
   Ddrb.4 = Dat.8
   !jmp Exits
Pir_5:
   Portb.4 = Dat.5
   Ddrb.2 = Dat.5
   Ddrb.4 = Dat.5
   !jmp Exits
Pir_6:
   Portb.2 = Dat.4
   Ddrb.2 = Dat.4
   Ddrb.4 = Dat.4
   !jmp Exits
Pir_7:
   Portb.1 = Dat.0
   Ddrb.1 = Dat.0
   Ddrb.4 = Dat.0
   !jmp Exits
Pir_8:
   Portb.4 = Dat.1
   Ddrb.1 = Dat.1
   Ddrb.4 = Dat.1
   !jmp Exits
Pir_9:
   Portb.1 = Dat.10
   Ddrb.1 = Dat.10
   Ddrb.3 = Dat.10
   !jmp Exits
Pir_10:
   Portb.3 = Dat.11
   Ddrb.1 = Dat.11
   Ddrb.3 = Dat.11
   !jmp Exits
Pir_11:
   Portb.2 = Dat.2
   Ddrb.1 = Dat.2
   Ddrb.2 = Dat.2
   !jmp Exits
Pir_12:
   Portb.1 = Dat.3
   Ddrb.1 = Dat.3
   Ddrb.2 = Dat.3
   !jmp Exits
Exits:
Return                                                      '  ,   

'==========  1==========
'***************************************************************************************
In_1hz:
   Incr Flg_1hz                                             '  
Return

'====================
'***************************************************************************************
Effects:

'2 
   Data &B000001000001%
   Data &B000010000010%
   Data &B000100000100%
   Data &B001000001000%
   Data &B010000010000%
   Data &B100000100000%
   Data &B000001000001%
   Data &B000010000010%
   Data &B000100000100%
   Data &B001000001000%
   Data &B010000010000%
   Data &B100000100000%
   Data &B000001000001%

'3 
   Data &B000100010001%
   Data &B001000100010%
   Data &B010001000100%
   Data &B100010001000%
   Data &B000100010001%
   Data &B001000100010%
   Data &B010001000100%
   Data &B100010001000%
   Data &B000100010001%
   Data &B001000100010%
   Data &B010001000100%
   Data &B100010001000%
   Data &B000100010001%

'4 
   Data &B001001001001%
   Data &B010010010010%
   Data &B100100100100%
   Data &B001001001001%
   Data &B010010010010%
   Data &B100100100100%
   Data &B001001001001%
   Data &B010010010010%
   Data &B100100100100%
   Data &B001001001001%
   Data &B010010010010%
   Data &B100100100100%
   Data &B001001001001%

'2 
   Data &B111110111110%
   Data &B111101111101%
   Data &B111011111011%
   Data &B110111110111%
   Data &B101111101111%
   Data &B011111011111%
   Data &B111110111110%
   Data &B111101111101%
   Data &B111011111011%
   Data &B110111110111%
   Data &B101111101111%
   Data &B011111011111%
   Data &B111110111110%

'3 
   Data &B111011101110%
   Data &B110111011101%
   Data &B101110111011%
   Data &B011101110111%
   Data &B111011101110%
   Data &B110111011101%
   Data &B101110111011%
   Data &B011101110111%
   Data &B111011101110%
   Data &B110111011101%
   Data &B101110111011%
   Data &B011101110111%
   Data &B111011101110%

'4 
   Data &B110110110110%
   Data &B101101101101%
   Data &B011011011011%
   Data &B110110110110%
   Data &B101101101101%
   Data &B011011011011%
   Data &B110110110110%
   Data &B101101101101%
   Data &B011011011011%
   Data &B110110110110%
   Data &B101101101101%
   Data &B011011011011%
   Data &B110110110110%


'2 
   Data &B000001000001%
   Data &B000011000011%
   Data &B000111000111%
   Data &B001111001111%
   Data &B011111011111%
   Data &B111111111111%
   Data &B111111111111%
   Data &B111110111110%
   Data &B111100111100%
   Data &B111000111000%
   Data &B110000110000%
   Data &B100000100000%
   Data &B000001000001%

'3 
   Data &B000100010001%
   Data &B001100110011%
   Data &B011101110111%
   Data &B111111111111%
   Data &B111011101110%
   Data &B110011001100%
   Data &B100010001000%
   Data &B100110011001%
   Data &B101110111011%
   Data &B111111111111%
   Data &B110111011101%
   Data &B100110011001%
   Data &B000100010001%

'====================
'***************************************************************************************
Pausis:
   Data 90 , 65 , 45 , 35 , 25 , 15 , 5 , 15 , 25 , 35 , 45 , 65 , 90